# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'CampaignDialerConfigArgs',
    'CampaignOutboundCallConfigArgs',
    'CampaignTagArgs',
]

@pulumi.input_type
class CampaignDialerConfigArgs:
    def __init__(__self__):
        """
        The possible types of dialer config parameters
        """
        pass


@pulumi.input_type
class CampaignOutboundCallConfigArgs:
    def __init__(__self__, *,
                 connect_contact_flow_arn: pulumi.Input[str],
                 connect_queue_arn: pulumi.Input[str],
                 connect_source_phone_number: Optional[pulumi.Input[str]] = None):
        """
        The configuration used for outbound calls.
        :param pulumi.Input[str] connect_contact_flow_arn: The identifier of the contact flow for the outbound call.
        :param pulumi.Input[str] connect_queue_arn: The queue for the call. If you specify a queue, the phone displayed for caller ID is the phone number specified in the queue. If you do not specify a queue, the queue defined in the contact flow is used. If you do not specify a queue, you must specify a source phone number.
        :param pulumi.Input[str] connect_source_phone_number: The phone number associated with the Amazon Connect instance, in E.164 format. If you do not specify a source phone number, you must specify a queue.
        """
        pulumi.set(__self__, "connect_contact_flow_arn", connect_contact_flow_arn)
        pulumi.set(__self__, "connect_queue_arn", connect_queue_arn)
        if connect_source_phone_number is not None:
            pulumi.set(__self__, "connect_source_phone_number", connect_source_phone_number)

    @property
    @pulumi.getter(name="connectContactFlowArn")
    def connect_contact_flow_arn(self) -> pulumi.Input[str]:
        """
        The identifier of the contact flow for the outbound call.
        """
        return pulumi.get(self, "connect_contact_flow_arn")

    @connect_contact_flow_arn.setter
    def connect_contact_flow_arn(self, value: pulumi.Input[str]):
        pulumi.set(self, "connect_contact_flow_arn", value)

    @property
    @pulumi.getter(name="connectQueueArn")
    def connect_queue_arn(self) -> pulumi.Input[str]:
        """
        The queue for the call. If you specify a queue, the phone displayed for caller ID is the phone number specified in the queue. If you do not specify a queue, the queue defined in the contact flow is used. If you do not specify a queue, you must specify a source phone number.
        """
        return pulumi.get(self, "connect_queue_arn")

    @connect_queue_arn.setter
    def connect_queue_arn(self, value: pulumi.Input[str]):
        pulumi.set(self, "connect_queue_arn", value)

    @property
    @pulumi.getter(name="connectSourcePhoneNumber")
    def connect_source_phone_number(self) -> Optional[pulumi.Input[str]]:
        """
        The phone number associated with the Amazon Connect instance, in E.164 format. If you do not specify a source phone number, you must specify a queue.
        """
        return pulumi.get(self, "connect_source_phone_number")

    @connect_source_phone_number.setter
    def connect_source_phone_number(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "connect_source_phone_number", value)


@pulumi.input_type
class CampaignTagArgs:
    def __init__(__self__, *,
                 key: pulumi.Input[str],
                 value: pulumi.Input[str]):
        """
        A key-value pair to associate with a resource.
        :param pulumi.Input[str] key: The key name of the tag. You can specify a value that is 1 to 128 Unicode characters in length and cannot be prefixed with aws:. You can use any of the following characters: the set of Unicode letters, digits, whitespace, _, ., /, =, +, and -. 
        :param pulumi.Input[str] value: The value for the tag. You can specify a value that's 1 to 256 characters in length.
        """
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Input[str]:
        """
        The key name of the tag. You can specify a value that is 1 to 128 Unicode characters in length and cannot be prefixed with aws:. You can use any of the following characters: the set of Unicode letters, digits, whitespace, _, ., /, =, +, and -. 
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: pulumi.Input[str]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[str]:
        """
        The value for the tag. You can specify a value that's 1 to 256 characters in length.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[str]):
        pulumi.set(self, "value", value)


